Subject: Re: bug#20102: Problem with ld.so RUNPATH on armhf

From: [email-masked] (Ludovic Courtès)
Date: Tue, 14 Jul 2015 15:32:36 +0200

[email-masked] (Ludovic Courtès) skribis:

> It happens on x86_64 as well.  Namely, the glibc that is built with
> glibc-final and gcc-final has extra RUNPATH entries:
>
> $ ./pre-inst-env guix build -e '(@ (gnu packages base) glibc)' -K
> [...]
> /gnu/store/pxi61vv6qj325y3zs5qpcy2shykgxdar-glibc-2.21
> /gnu/store/m3qidd4gx7ry3wxagsrd9cwlykq90yi7-glibc-2.21-debug
> $ /gnu/store/pxi61vv6qj325y3zs5qpcy2shykgxdar-glibc-2.21/bin/gencat 
> Inconsistency detected by ld.so: get-dynamic-info.h: 142: elf_get_dynamic_info: Assertion `info[29] == ((void *)0)' failed!
> $ objdump -x /gnu/store/pxi61vv6qj325y3zs5qpcy2shykgxdar-glibc-2.21/bin/gencat |grep PATH
>   RUNPATH              /gnu/store/2bq2qaaajar2f3dbxrrwssxfrfi0k9zr-gcc-4.9.2/libexec/gcc/x86_64-unknown-linux-gnu/4.9.2
>
> After a bit of investigation, I found that the problem came from:
>
>   -plugin /gnu/store/2bq2qaaajar2f3dbxrrwssxfrfi0k9zr-gcc-4.9.2/libexec/gcc/x86_64-unknown-linux-gnu/4.9.2/liblto_plugin.so.0
>
> which led ld-wrapper to add a -rpath flag for that directory.
>
> I’m testing the patch below and will commit tomorrow if everything goes
> well.

The patch was applied as b5616bc a while back, so I’m closing this bug.

Ludo’.